/*----- Sección de Declaraciones --------------*/ 
%{
#include <stdio.h>

  FILE* entrada;
  FILE* salida;
  int  nhiper, ncorreo;
  void escribir_datos (int dato1, int dato2);
%}

file_char	([A-Za-z][0-9])

%%
/*----- Sección de Reglas ----------------*/ 

\"(h|H)(t|T)(t|T)(p|P)\:[^\"]*\"  {ECHO, fprintf (salida, "\n");nhiper++;}
{file_char}+@{file_char}+         {ECHO, fprintf (salida, "\n");ncorreo++;}
.|\n                              {}

%%
/*----- Sección de Procedimientos --------*/ 

int main (int argc, char *argv[])
{   
  if (argc ==3)
    {
      entrada = fopen (argv[1], "r");
      salida = fopen (argv[2], "w");
      if ( entrada == NULL)
        {
	  printf ("No puedeo abrir el fichero %s .\n", argv[1]);
	  exit(-1);
        }
      if ( salida == NULL)
        {
	  printf ("No puedeo crear o sobreescribir el fichero %s .\n", argv[2]);
	  exit(-1);
        }
    }
  else
    {
      printf ("\nNecesito los nombres de los ficheros de entrada y salida para seguir.\n");
      exit(-1);
    }

  nhiper = ncorreo = 0;
  
  yyin = entrada;
  yylex ();   
  
  escribir_datos(nhiper, ncorreo);

  fclose(salida);
  fclose(entrada);

  return 0; 
}

void escribir_datos (int dato1, int dato2) 
{
  printf ("Hiper= %d\tCorreos=%d\n",dato1, dato2);   
}

