/***************************************************************************
 *                                                                         *
 *   MAILCRAWL                                                             *
 *   =========                                                             *
 *                                                                         *
 *   Copyright (C)                                                         *
 *   Juan Pedro Bolivar Puente                                             *
 *   Francisco Manuel Herrero Pérez                                        *
 *   2007                                                                  *
 *                                                                         *
 *   This program is free software: you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation, either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>. *
 *                                                                         *
 ***************************************************************************/

#ifndef CACHE_H
#define CACHE_H

#include "common.h"
#include "gl_oset.h"

struct idxstr_s 
{
  char* str;
  size_t idx;
};

typedef struct idxstr_s idxstr_t;
typedef idxstr_t* idxstr_p;

struct cache_s
{
  size_t index;
  gl_oset_t data;
};

typedef struct cache_s cache_t;
typedef cache_t* cache_p;

cache_p
cache_create();

void
cache_free(cache_p c);

void
cache_adjust(cache_p, int size);

bool
cache_add(cache_p, char* str);

INLINE size_t
cache_size(cache_p c)
{
  return c->index;
}

#endif /* CACHE_H */
