/***************************************************************************
 *                                                                         *
 *   MAILCRAWL                                                             *
 *   =========                                                             *
 *                                                                         *
 *   Copyright (C)                                                         *
 *   Juan Pedro Bolivar Puente                                             *
 *   Francisco Manuel Herrero Pérez                                        *
 *   2009                                                                  *
 *                                                                         *
 *   This program is free software: you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation, either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>. *
 *                                                                         *
 ***************************************************************************/

#ifndef THREAD_POOL_H
#define THREAD_POOL_H

#include <pthread.h>
#include "common.h"

struct thread_pool_s;
typedef struct thread_pool_s thread_pool_t;
typedef thread_pool_t* thread_pool_p;

typedef int thread_pool_task_id_t;

thread_pool_p
thread_pool_create (size_t num_threads);

void
thread_pool_free (thread_pool_p tp);

thread_pool_task_id_t
thread_pool_execute (thread_pool_p tp,
		     void (*func) (void*),
		     void* data);

void
thread_pool_join (thread_pool_p tp);

size_t
thread_pool_num_working (thread_pool_p tp);


#endif /* THREAD_POOL_H */
